diff -crBPN --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=1.html --exclude=2.html --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.7.pl /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-upgrader.php /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-upgrader.php
*** /home/packages/code/qi/SOURCES/wordpress-3.6.1/wp-admin/includes/class-wp-upgrader.php	2013-06-21 00:54:40.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.7/wp-admin/includes/class-wp-upgrader.php	2013-10-23 21:00:09.000000000 -0500
***************
*** 11,21 ****
   * @since 2.8.0
   */
  
  /**
   * WordPress Upgrader class for Upgrading/Installing a local set of files via the Filesystem Abstraction classes from a Zip file.
   *
-  * @TODO More Detailed docs, for methods as well.
-  *
   * @package WordPress
   * @subpackage Upgrader
   * @since 2.8.0
--- 11,21 ----
   * @since 2.8.0
   */
  
+ require ABSPATH . 'wp-admin/includes/class-wp-upgrader-skins.php';
+ 
  /**
   * WordPress Upgrader class for Upgrading/Installing a local set of files via the Filesystem Abstraction classes from a Zip file.
   *
   * @package WordPress
   * @subpackage Upgrader
   * @since 2.8.0
***************
*** 93,100 ****
  					if ( ! $wp_filesystem->wp_plugins_dir() )
  						return new WP_Error('fs_no_plugins_dir', $this->strings['fs_no_plugins_dir']);
  					break;
! 				case WP_CONTENT_DIR . '/themes':
! 					if ( ! $wp_filesystem->find_folder(WP_CONTENT_DIR . '/themes') )
  						return new WP_Error('fs_no_themes_dir', $this->strings['fs_no_themes_dir']);
  					break;
  				default:
--- 93,100 ----
  					if ( ! $wp_filesystem->wp_plugins_dir() )
  						return new WP_Error('fs_no_plugins_dir', $this->strings['fs_no_plugins_dir']);
  					break;
! 				case get_theme_root():
! 					if ( ! $wp_filesystem->wp_themes_dir() )
  						return new WP_Error('fs_no_themes_dir', $this->strings['fs_no_themes_dir']);
  					break;
  				default:
***************
*** 108,113 ****
--- 108,126 ----
  
  	function download_package($package) {
  
+ 		/**
+ 		 * Filter whether to return the package.
+ 		 *
+ 		 * @since 3.7.0
+ 		 *
+ 		 * @param bool    $reply   Whether to bail without returning the package. Default is false.
+ 		 * @param string  $package The package file name.
+ 		 * @param object  $this    The WP_Upgrader instance.
+ 		 */
+ 		$reply = apply_filters( 'upgrader_pre_download', false, $package, $this );
+ 		if ( false !== $reply )
+ 			return $reply;
+ 
  		if ( ! preg_match('!^(http|https|ftp)://!i', $package) && file_exists($package) ) //Local file or remote?
  			return $package; //must be a local file..
  
***************
*** 146,152 ****
  			$wp_filesystem->delete($working_dir, true);
  
  		// Unzip package to working directory
! 		$result = unzip_file($package, $working_dir); //TODO optimizations, Copy when Move/Rename would suffice?
  
  		// Once extracted, delete the package if required.
  		if ( $delete_package )
--- 159,165 ----
  			$wp_filesystem->delete($working_dir, true);
  
  		// Unzip package to working directory
! 		$result = unzip_file( $package, $working_dir );
  
  		// Once extracted, delete the package if required.
  		if ( $delete_package )
***************
*** 163,174 ****
  		return $working_dir;
  	}
  
! 	function install_package($args = array()) {
! 		global $wp_filesystem;
! 		$defaults = array( 'source' => '', 'destination' => '', //Please always pass these
! 						'clear_destination' => false, 'clear_working' => false,
! 						'abort_if_destination_exists' => true,
! 						'hook_extra' => array());
  
  		$args = wp_parse_args($args, $defaults);
  		extract($args);
--- 176,192 ----
  		return $working_dir;
  	}
  
! 	function install_package( $args = array() ) {
! 		global $wp_filesystem, $wp_theme_directories;
! 
! 		$defaults = array(
! 			'source' => '', // Please always pass this
! 			'destination' => '', // and this
! 			'clear_destination' => false,
! 			'clear_working' => false,
! 			'abort_if_destination_exists' => true,
! 			'hook_extra' => array()
! 		);
  
  		$args = wp_parse_args($args, $defaults);
  		extract($args);
***************
*** 195,201 ****
  		if ( 1 == count($source_files) && $wp_filesystem->is_dir( trailingslashit($source) . $source_files[0] . '/') ) //Only one folder? Then we want its contents.
  			$source = trailingslashit($source) . trailingslashit($source_files[0]);
  		elseif ( count($source_files) == 0 )
! 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], $this->strings['no_files'] ); //There are no files?
  		else //It's only a single file, the upgrader will use the foldername of this file as the destination folder. foldername is based on zip filename.
  			$source = trailingslashit($source);
  
--- 213,219 ----
  		if ( 1 == count($source_files) && $wp_filesystem->is_dir( trailingslashit($source) . $source_files[0] . '/') ) //Only one folder? Then we want its contents.
  			$source = trailingslashit($source) . trailingslashit($source_files[0]);
  		elseif ( count($source_files) == 0 )
! 			return new WP_Error( 'incompatible_archive_empty', $this->strings['incompatible_archive'], $this->strings['no_files'] ); // There are no files?
  		else //It's only a single file, the upgrader will use the foldername of this file as the destination folder. foldername is based on zip filename.
  			$source = trailingslashit($source);
  
***************
*** 208,215 ****
  		if ( $source !== $remote_source )
  			$source_files = array_keys( $wp_filesystem->dirlist($source) );
  
! 		//Protection against deleting files in any important base directories.
! 		if ( in_array( $destination, array(ABSPATH, WP_CONTENT_DIR, WP_PLUGIN_DIR, WP_CONTENT_DIR . '/themes') ) ) {
  			$remote_destination = trailingslashit($remote_destination) . trailingslashit(basename($source));
  			$destination = trailingslashit($destination) . trailingslashit(basename($source));
  		}
--- 226,238 ----
  		if ( $source !== $remote_source )
  			$source_files = array_keys( $wp_filesystem->dirlist($source) );
  
! 		// Protection against deleting files in any important base directories.
! 		// Theme_Upgrader & Plugin_Upgrader also trigger this, as they pass the destination directory (WP_PLUGIN_DIR / wp-content/themes)
! 		// intending to copy the directory into the directory, whilst they pass the source as the actual files to copy.
! 		$protected_directories = array( ABSPATH, WP_CONTENT_DIR, WP_PLUGIN_DIR, WP_CONTENT_DIR . '/themes' );
! 		if ( is_array( $wp_theme_directories ) )
! 			$protected_directories = array_merge( $protected_directories, $wp_theme_directories );
! 		if ( in_array( $destination, $protected_directories ) ) {
  			$remote_destination = trailingslashit($remote_destination) . trailingslashit(basename($source));
  			$destination = trailingslashit($destination) . trailingslashit(basename($source));
  		}
***************
*** 239,245 ****
  		//Create destination if needed
  		if ( !$wp_filesystem->exists($remote_destination) )
  			if ( !$wp_filesystem->mkdir($remote_destination, FS_CHMOD_DIR) )
! 				return new WP_Error('mkdir_failed', $this->strings['mkdir_failed'], $remote_destination);
  
  		// Copy new version of item into place.
  		$result = copy_dir($source, $remote_destination);
--- 262,268 ----
  		//Create destination if needed
  		if ( !$wp_filesystem->exists($remote_destination) )
  			if ( !$wp_filesystem->mkdir($remote_destination, FS_CHMOD_DIR) )
! 				return new WP_Error( 'mkdir_failed_destination', $this->strings['mkdir_failed'], $remote_destination );
  
  		// Copy new version of item into place.
  		$result = copy_dir($source, $remote_destination);
***************
*** 271,308 ****
  
  	function run($options) {
  
! 		$defaults = array( 	'package' => '', //Please always pass this.
! 							'destination' => '', //And this
! 							'clear_destination' => false,
! 							'abort_if_destination_exists' => true, // Abort if the Destination directory exists, Pass clear_destination as false please
! 							'clear_working' => true,
! 							'is_multi' => false,
! 							'hook_extra' => array() //Pass any extra $hook_extra args here, this will be passed to any hooked filters.
! 						);
  
  		$options = wp_parse_args($options, $defaults);
  		extract($options);
  
! 		//Connect to the Filesystem first.
  		$res = $this->fs_connect( array(WP_CONTENT_DIR, $destination) );
! 		if ( ! $res ) //Mainly for non-connected filesystem.
  			return false;
  
  		if ( is_wp_error($res) ) {
  			$this->skin->error($res);
  			return $res;
  		}
  
- 		if ( !$is_multi ) // call $this->header separately if running multiple times
- 			$this->skin->header();
- 
- 		$this->skin->before();
- 
  		//Download the package (Note, This just returns the filename of the file if the package is a local file)
  		$download = $this->download_package( $package );
  		if ( is_wp_error($download) ) {
  			$this->skin->error($download);
  			$this->skin->after();
  			return $download;
  		}
  
--- 294,341 ----
  
  	function run($options) {
  
! 		$defaults = array(
! 			'package' => '', // Please always pass this.
! 			'destination' => '', // And this
! 			'clear_destination' => false,
! 			'abort_if_destination_exists' => true, // Abort if the Destination directory exists, Pass clear_destination as false please
! 			'clear_working' => true,
! 			'is_multi' => false,
! 			'hook_extra' => array() // Pass any extra $hook_extra args here, this will be passed to any hooked filters.
! 		);
  
  		$options = wp_parse_args($options, $defaults);
  		extract($options);
  
! 		if ( ! $is_multi ) // call $this->header separately if running multiple times
! 			$this->skin->header();
! 
! 		// Connect to the Filesystem first.
  		$res = $this->fs_connect( array(WP_CONTENT_DIR, $destination) );
! 		// Mainly for non-connected filesystem.
! 		if ( ! $res ) {
! 			if ( ! $is_multi )
! 				$this->skin->footer();
  			return false;
+ 		}
+ 
+ 		$this->skin->before();
  
  		if ( is_wp_error($res) ) {
  			$this->skin->error($res);
+ 			$this->skin->after();
+ 			if ( ! $is_multi )
+ 				$this->skin->footer();
  			return $res;
  		}
  
  		//Download the package (Note, This just returns the filename of the file if the package is a local file)
  		$download = $this->download_package( $package );
  		if ( is_wp_error($download) ) {
  			$this->skin->error($download);
  			$this->skin->after();
+ 			if ( ! $is_multi )
+ 				$this->skin->footer();
  			return $download;
  		}
  
***************
*** 313,330 ****
  		if ( is_wp_error($working_dir) ) {
  			$this->skin->error($working_dir);
  			$this->skin->after();
  			return $working_dir;
  		}
  
  		//With the given options, this installs it to the destination directory.
  		$result = $this->install_package( array(
! 											'source' => $working_dir,
! 											'destination' => $destination,
! 											'clear_destination' => $clear_destination,
! 											'abort_if_destination_exists' => $abort_if_destination_exists,
! 											'clear_working' => $clear_working,
! 											'hook_extra' => $hook_extra
! 										) );
  		$this->skin->set_result($result);
  		if ( is_wp_error($result) ) {
  			$this->skin->error($result);
--- 346,366 ----
  		if ( is_wp_error($working_dir) ) {
  			$this->skin->error($working_dir);
  			$this->skin->after();
+ 			if ( ! $is_multi )
+ 				$this->skin->footer();
  			return $working_dir;
  		}
  
  		//With the given options, this installs it to the destination directory.
  		$result = $this->install_package( array(
! 			'source' => $working_dir,
! 			'destination' => $destination,
! 			'clear_destination' => $clear_destination,
! 			'abort_if_destination_exists' => $abort_if_destination_exists,
! 			'clear_working' => $clear_working,
! 			'hook_extra' => $hook_extra
! 		) );
! 
  		$this->skin->set_result($result);
  		if ( is_wp_error($result) ) {
  			$this->skin->error($result);
***************
*** 333,342 ****
  			//Install Succeeded
  			$this->skin->feedback('process_success');
  		}
  		$this->skin->after();
  
! 		if ( !$is_multi )
  			$this->skin->footer();
  
  		return $result;
  	}
--- 369,381 ----
  			//Install Succeeded
  			$this->skin->feedback('process_success');
  		}
+ 
  		$this->skin->after();
  
! 		if ( ! $is_multi ) {
! 			do_action( 'upgrader_process_complete', $this, $hook_extra );
  			$this->skin->footer();
+ 		}
  
  		return $result;
  	}
***************
*** 361,368 ****
  /**
   * Plugin Upgrader class for WordPress Plugins, It is designed to upgrade/install plugins from a local zip, remote zip URL, or uploaded zip file.
   *
-  * @TODO More Detailed docs, for methods as well.
-  *
   * @package WordPress
   * @subpackage Upgrader
   * @since 2.8.0
--- 400,405 ----
***************
*** 394,428 ****
  		$this->strings['process_success'] = __('Plugin installed successfully.');
  	}
  
! 	function install($package) {
  
  		$this->init();
  		$this->install_strings();
  
! 		add_filter('upgrader_source_selection', array(&$this, 'check_package') );
  
! 		$this->run(array(
! 					'package' => $package,
! 					'destination' => WP_PLUGIN_DIR,
! 					'clear_destination' => false, //Do not overwrite files.
! 					'clear_working' => true,
! 					'hook_extra' => array()
! 					));
  
! 		remove_filter('upgrader_source_selection', array(&$this, 'check_package') );
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
  		// Force refresh of plugin update information
! 		delete_site_transient('update_plugins');
! 		wp_cache_delete( 'plugins', 'plugins' );
! 		do_action( 'upgrader_process_complete', $this, array( 'action' => 'install', 'type' => 'plugin' ), $package );
  
  		return true;
  	}
  
! 	function upgrade($plugin) {
  
  		$this->init();
  		$this->upgrade_strings();
--- 431,476 ----
  		$this->strings['process_success'] = __('Plugin installed successfully.');
  	}
  
! 	function install( $package, $args = array() ) {
! 
! 		$defaults = array(
! 			'clear_update_cache' => true,
! 		);
! 		$parsed_args = wp_parse_args( $args, $defaults );
  
  		$this->init();
  		$this->install_strings();
  
! 		add_filter('upgrader_source_selection', array($this, 'check_package') );
  
! 		$this->run( array(
! 			'package' => $package,
! 			'destination' => WP_PLUGIN_DIR,
! 			'clear_destination' => false, // Do not overwrite files.
! 			'clear_working' => true,
! 			'hook_extra' => array(
! 				'type' => 'plugin',
! 				'action' => 'install',
! 			)
! 		) );
  
! 		remove_filter('upgrader_source_selection', array($this, 'check_package') );
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
  		// Force refresh of plugin update information
! 		wp_clean_plugins_cache( $parsed_args['clear_update_cache'] );
  
  		return true;
  	}
  
! 	function upgrade( $plugin, $args = array() ) {
! 
! 		$defaults = array(
! 			'clear_update_cache' => true,
! 		);
! 		$parsed_args = wp_parse_args( $args, $defaults );
  
  		$this->init();
  		$this->upgrade_strings();
***************
*** 439,472 ****
  		// Get the URL to the zip file
  		$r = $current->response[ $plugin ];
  
! 		add_filter('upgrader_pre_install', array(&$this, 'deactivate_plugin_before_upgrade'), 10, 2);
! 		add_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'), 10, 4);
! 		//'source_selection' => array(&$this, 'source_selection'), //there's a trac ticket to move up the directory for zip's which are made a bit differently, useful for non-.org plugins.
! 
! 		$this->run(array(
! 					'package' => $r->package,
! 					'destination' => WP_PLUGIN_DIR,
! 					'clear_destination' => true,
! 					'clear_working' => true,
! 					'hook_extra' => array(
! 								'plugin' => $plugin
! 					)
! 				));
  
  		// Cleanup our hooks, in case something else does a upgrade on this connection.
! 		remove_filter('upgrader_pre_install', array(&$this, 'deactivate_plugin_before_upgrade'));
! 		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'));
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
  		// Force refresh of plugin update information
! 		delete_site_transient('update_plugins');
! 		wp_cache_delete( 'plugins', 'plugins' );
! 		do_action( 'upgrader_process_complete', $this, array( 'action' => 'update', 'type' => 'plugin' ), $plugin );
  	}
  
! 	function bulk_upgrade($plugins) {
  
  		$this->init();
  		$this->bulk = true;
--- 487,527 ----
  		// Get the URL to the zip file
  		$r = $current->response[ $plugin ];
  
! 		add_filter('upgrader_pre_install', array($this, 'deactivate_plugin_before_upgrade'), 10, 2);
! 		add_filter('upgrader_clear_destination', array($this, 'delete_old_plugin'), 10, 4);
! 		//'source_selection' => array($this, 'source_selection'), //there's a trac ticket to move up the directory for zip's which are made a bit differently, useful for non-.org plugins.
! 
! 		$this->run( array(
! 			'package' => $r->package,
! 			'destination' => WP_PLUGIN_DIR,
! 			'clear_destination' => true,
! 			'clear_working' => true,
! 			'hook_extra' => array(
! 				'plugin' => $plugin,
! 				'type' => 'plugin',
! 				'action' => 'update',
! 			),
! 		) );
  
  		// Cleanup our hooks, in case something else does a upgrade on this connection.
! 		remove_filter('upgrader_pre_install', array($this, 'deactivate_plugin_before_upgrade'));
! 		remove_filter('upgrader_clear_destination', array($this, 'delete_old_plugin'));
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
  		// Force refresh of plugin update information
! 		wp_clean_plugins_cache( $parsed_args['clear_update_cache'] );
! 
! 		return true;
  	}
  
! 	function bulk_upgrade( $plugins, $args = array() ) {
! 
! 		$defaults = array(
! 			'clear_update_cache' => true,
! 		);
! 		$parsed_args = wp_parse_args( $args, $defaults );
  
  		$this->init();
  		$this->bulk = true;
***************
*** 474,480 ****
  
  		$current = get_site_transient( 'update_plugins' );
  
! 		add_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'), 10, 4);
  
  		$this->skin->header();
  
--- 529,535 ----
  
  		$current = get_site_transient( 'update_plugins' );
  
! 		add_filter('upgrader_clear_destination', array($this, 'delete_old_plugin'), 10, 4);
  
  		$this->skin->header();
  
***************
*** 487,496 ****
  
  		$this->skin->bulk_header();
  
! 		// Only start maintenance mode if running in Multisite OR the plugin is in use
! 		$maintenance = is_multisite(); // @TODO: This should only kick in for individual sites if at all possible.
  		foreach ( $plugins as $plugin )
! 			$maintenance = $maintenance || (is_plugin_active($plugin) && isset($current->response[ $plugin ]) ); // Only activate Maintenance mode if a plugin is active AND has an update available
  		if ( $maintenance )
  			$this->maintenance_mode(true);
  
--- 542,554 ----
  
  		$this->skin->bulk_header();
  
! 		// Only start maintenance mode if:
! 		// - running Multisite and there are one or more plugins specified, OR
! 		// - a plugin with an update available is currently active.
! 		// @TODO: For multisite, maintenance mode should only kick in for individual sites if at all possible.
! 		$maintenance = ( is_multisite() && ! empty( $plugins ) );
  		foreach ( $plugins as $plugin )
! 			$maintenance = $maintenance || ( is_plugin_active( $plugin ) && isset( $current->response[ $plugin] ) );
  		if ( $maintenance )
  			$this->maintenance_mode(true);
  
***************
*** 516,531 ****
  
  			$this->skin->plugin_active = is_plugin_active($plugin);
  
! 			$result = $this->run(array(
! 						'package' => $r->package,
! 						'destination' => WP_PLUGIN_DIR,
! 						'clear_destination' => true,
! 						'clear_working' => true,
! 						'is_multi' => true,
! 						'hook_extra' => array(
! 									'plugin' => $plugin
! 						)
! 					));
  
  			$results[$plugin] = $this->result;
  
--- 574,589 ----
  
  			$this->skin->plugin_active = is_plugin_active($plugin);
  
! 			$result = $this->run( array(
! 				'package' => $r->package,
! 				'destination' => WP_PLUGIN_DIR,
! 				'clear_destination' => true,
! 				'clear_working' => true,
! 				'is_multi' => true,
! 				'hook_extra' => array(
! 					'plugin' => $plugin
! 				)
! 			) );
  
  			$results[$plugin] = $this->result;
  
***************
*** 536,552 ****
  
  		$this->maintenance_mode(false);
  
  		$this->skin->bulk_footer();
  
  		$this->skin->footer();
  
  		// Cleanup our hooks, in case something else does a upgrade on this connection.
! 		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_plugin'));
  
  		// Force refresh of plugin update information
! 		delete_site_transient('update_plugins');
! 		wp_cache_delete( 'plugins', 'plugins' );
! 		do_action( 'upgrader_process_complete', $this, array( 'action' => 'update', 'type' => 'plugin', 'bulk' => true ), $plugins );
  
  		return $results;
  	}
--- 594,615 ----
  
  		$this->maintenance_mode(false);
  
+ 		do_action( 'upgrader_process_complete', $this, array(
+ 			'action' => 'update',
+ 			'type' => 'plugin',
+ 			'bulk' => true,
+ 			'plugins' => $plugins,
+ 		) );
+ 
  		$this->skin->bulk_footer();
  
  		$this->skin->footer();
  
  		// Cleanup our hooks, in case something else does a upgrade on this connection.
! 		remove_filter('upgrader_clear_destination', array($this, 'delete_old_plugin'));
  
  		// Force refresh of plugin update information
! 		wp_clean_plugins_cache( $parsed_args['clear_update_cache'] );
  
  		return $results;
  	}
***************
*** 572,578 ****
  		}
  
  		if ( ! $plugins_found )
! 			return new WP_Error( 'incompatible_archive', $this->strings['incompatible_archive'], __('No valid plugins were found.') );
  
  		return $source;
  	}
--- 635,641 ----
  		}
  
  		if ( ! $plugins_found )
! 			return new WP_Error( 'incompatible_archive_no_plugins', $this->strings['incompatible_archive'], __( 'No valid plugins were found.' ) );
  
  		return $source;
  	}
***************
*** 599,604 ****
--- 662,671 ----
  		if ( is_wp_error($return) ) //Bypass.
  			return $return;
  
+ 		// When in cron (background updates) don't deactivate the plugin, as we require a browser to reactivate it
+ 		if ( defined( 'DOING_CRON' ) && DOING_CRON )
+ 			return $return;
+ 
  		$plugin = isset($plugin['plugin']) ? $plugin['plugin'] : '';
  		if ( empty($plugin) )
  			return new WP_Error('bad_request', $this->strings['bad_request']);
***************
*** 642,649 ****
  /**
   * Theme Upgrader class for WordPress Themes, It is designed to upgrade/install themes from a local zip, remote zip URL, or uploaded zip file.
   *
-  * @TODO More Detailed docs, for methods as well.
-  *
   * @package WordPress
   * @subpackage Upgrader
   * @since 2.8.0
--- 709,714 ----
***************
*** 705,711 ****
  		if ( ! $api || is_wp_error($api) ) {
  			$this->skin->feedback( 'parent_theme_not_found', $theme_info->get('Template') );
  			// Don't show activate or preview actions after install
! 			add_filter('install_theme_complete_actions', array(&$this, 'hide_activate_preview_actions') );
  			return $install_result;
  		}
  
--- 770,776 ----
  		if ( ! $api || is_wp_error($api) ) {
  			$this->skin->feedback( 'parent_theme_not_found', $theme_info->get('Template') );
  			// Don't show activate or preview actions after install
! 			add_filter('install_theme_complete_actions', array($this, 'hide_activate_preview_actions') );
  			return $install_result;
  		}
  
***************
*** 724,736 ****
  		// Install the parent theme
  		$parent_result = $this->run( array(
  			'package' => $api->download_link,
! 			'destination' => WP_CONTENT_DIR . '/themes',
  			'clear_destination' => false, //Do not overwrite files.
  			'clear_working' => true
  		) );
  
  		if ( is_wp_error($parent_result) )
! 			add_filter('install_theme_complete_actions', array(&$this, 'hide_activate_preview_actions') );
  
  		// Start cleaning up after the parents installation
  		remove_filter('install_theme_complete_actions', '__return_false', 999);
--- 789,801 ----
  		// Install the parent theme
  		$parent_result = $this->run( array(
  			'package' => $api->download_link,
! 			'destination' => get_theme_root(),
  			'clear_destination' => false, //Do not overwrite files.
  			'clear_working' => true
  		) );
  
  		if ( is_wp_error($parent_result) )
! 			add_filter('install_theme_complete_actions', array($this, 'hide_activate_preview_actions') );
  
  		// Start cleaning up after the parents installation
  		remove_filter('install_theme_complete_actions', '__return_false', 999);
***************
*** 748,784 ****
  		return $actions;
  	}
  
! 	function install($package) {
  
  		$this->init();
  		$this->install_strings();
  
! 		add_filter('upgrader_source_selection', array(&$this, 'check_package') );
! 		add_filter('upgrader_post_install', array(&$this, 'check_parent_theme_filter'), 10, 3);
! 
! 		$options = array(
! 						'package' => $package,
! 						'destination' => WP_CONTENT_DIR . '/themes',
! 						'clear_destination' => false, //Do not overwrite files.
! 						'clear_working' => true
! 						);
  
! 		$this->run($options);
  
! 		remove_filter('upgrader_source_selection', array(&$this, 'check_package') );
! 		remove_filter('upgrader_post_install', array(&$this, 'check_parent_theme_filter'));
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
! 		// Force refresh of theme update information
! 		wp_clean_themes_cache();
! 		do_action( 'upgrader_process_complete', $this, array( 'action' => 'install', 'type' => 'theme' ), $package );
  
  		return true;
  	}
  
! 	function upgrade($theme) {
  
  		$this->init();
  		$this->upgrade_strings();
--- 813,860 ----
  		return $actions;
  	}
  
! 	function install( $package, $args = array() ) {
! 
! 		$defaults = array(
! 			'clear_update_cache' => true,
! 		);
! 		$parsed_args = wp_parse_args( $args, $defaults );
  
  		$this->init();
  		$this->install_strings();
  
! 		add_filter('upgrader_source_selection', array($this, 'check_package') );
! 		add_filter('upgrader_post_install', array($this, 'check_parent_theme_filter'), 10, 3);
  
! 		$this->run( array(
! 			'package' => $package,
! 			'destination' => get_theme_root(),
! 			'clear_destination' => false, //Do not overwrite files.
! 			'clear_working' => true,
! 			'hook_extra' => array(
! 				'type' => 'theme',
! 				'action' => 'install',
! 			),
! 		) );
  
! 		remove_filter('upgrader_source_selection', array($this, 'check_package') );
! 		remove_filter('upgrader_post_install', array($this, 'check_parent_theme_filter'));
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
! 		// Refresh the Theme Update information
! 		wp_clean_themes_cache( $parsed_args['clear_update_cache'] );
  
  		return true;
  	}
  
! 	function upgrade( $theme, $args = array() ) {
! 
! 		$defaults = array(
! 			'clear_update_cache' => true,
! 		);
! 		$parsed_args = wp_parse_args( $args, $defaults );
  
  		$this->init();
  		$this->upgrade_strings();
***************
*** 795,831 ****
  
  		$r = $current->response[ $theme ];
  
! 		add_filter('upgrader_pre_install', array(&$this, 'current_before'), 10, 2);
! 		add_filter('upgrader_post_install', array(&$this, 'current_after'), 10, 2);
! 		add_filter('upgrader_clear_destination', array(&$this, 'delete_old_theme'), 10, 4);
! 
! 		$options = array(
! 						'package' => $r['package'],
! 						'destination' => WP_CONTENT_DIR . '/themes',
! 						'clear_destination' => true,
! 						'clear_working' => true,
! 						'hook_extra' => array(
! 											'theme' => $theme
! 											)
! 						);
! 
! 		$this->run($options);
! 
! 		remove_filter('upgrader_pre_install', array(&$this, 'current_before'));
! 		remove_filter('upgrader_post_install', array(&$this, 'current_after'));
! 		remove_filter('upgrader_clear_destination', array(&$this, 'delete_old_theme'));
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
! 		// Force refresh of theme update information
! 		wp_clean_themes_cache();
! 		do_action( 'upgrader_process_complete', $this, array( 'action' => 'update', 'type' => 'theme' ), $theme );
  
  		return true;
  	}
  
! 	function bulk_upgrade($themes) {
  
  		$this->init();
  		$this->bulk = true;
--- 871,910 ----
  
  		$r = $current->response[ $theme ];
  
! 		add_filter('upgrader_pre_install', array($this, 'current_before'), 10, 2);
! 		add_filter('upgrader_post_install', array($this, 'current_after'), 10, 2);
! 		add_filter('upgrader_clear_destination', array($this, 'delete_old_theme'), 10, 4);
! 
! 		$this->run( array(
! 			'package' => $r['package'],
! 			'destination' => get_theme_root( $theme ),
! 			'clear_destination' => true,
! 			'clear_working' => true,
! 			'hook_extra' => array(
! 				'theme' => $theme,
! 				'type' => 'theme',
! 				'action' => 'update',
! 			),
! 		) );
! 
! 		remove_filter('upgrader_pre_install', array($this, 'current_before'));
! 		remove_filter('upgrader_post_install', array($this, 'current_after'));
! 		remove_filter('upgrader_clear_destination', array($this, 'delete_old_theme'));
  
  		if ( ! $this->result || is_wp_error($this->result) )
  			return $this->result;
  
! 		wp_clean_themes_cache( $parsed_args['clear_update_cache'] );
  
  		return true;
  	}
  
! 	function bulk_upgrade( $themes, $args = array() ) {
! 
! 		$defaults = array(
! 			'clear_update_cache' => true,
! 		);
! 		$parsed_args = wp_parse_args( $args, $defaults );
  
  		$this->init();
  		$this->bulk = true;
***************
*** 833,841 ****
  
  		$current = get_site_transient( 'update_themes' );
  
! 		add_filter('upgrader_pre_install', array(&$this, 'current_before'), 10, 2);
! 		add_filter('upgrader_post_install', array(&$this, 'current_after'), 10, 2);
! 		add_filter('upgrader_clear_destination', array(&$this, 'delete_old_theme'), 10, 4);
  
  		$this->skin->header();
  
--- 912,920 ----
  
  		$current = get_site_transient( 'update_themes' );
  
! 		add_filter('upgrader_pre_install', array($this, 'current_before'), 10, 2);
! 		add_filter('upgrader_post_install', array($this, 'current_after'), 10, 2);
! 		add_filter('upgrader_clear_destination', array($this, 'delete_old_theme'), 10, 4);
  
  		$this->skin->header();
  
***************
*** 848,855 ****
  
  		$this->skin->bulk_header();
  
! 		// Only start maintenance mode if running in Multisite OR the theme is in use
! 		$maintenance = is_multisite(); // @TODO: This should only kick in for individual sites if at all possible.
  		foreach ( $themes as $theme )
  			$maintenance = $maintenance || $theme == get_stylesheet() || $theme == get_template();
  		if ( $maintenance )
--- 927,937 ----
  
  		$this->skin->bulk_header();
  
! 		// Only start maintenance mode if:
! 		// - running Multisite and there are one or more themes specified, OR
! 		// - a theme with an update available is currently in use.
! 		// @TODO: For multisite, maintenance mode should only kick in for individual sites if at all possible.
! 		$maintenance = ( is_multisite() && ! empty( $themes ) );
  		foreach ( $themes as $theme )
  			$maintenance = $maintenance || $theme == get_stylesheet() || $theme == get_template();
  		if ( $maintenance )
